<template>
  <div class="main-page">
    <div class="main-page-header">
      <p class="title">急诊站点资源</p>
      <el-form
        :inline="true"
        :model="searchForm"
        ref="searchForm"
        size="small"
      >
        <el-form-item
          label="站点名称"
          prop="siteName"
        >
          <el-input
            placeholder="请输入站点名称"
            v-model="searchForm.siteName"
          />
        </el-form-item>
        <el-form-item
          prop="area"
          label="辖区"
        >
          <el-select
            v-model="searchForm.area"
            placeholder="请选择辖区"
            style="width: 100%"
            :clearable="true"
          >
            <el-option
              v-for="item in areaList"
              :label="item.name"
              :key="item.id"
              :value="item.val"
            />
          </el-select>
        </el-form-item>
        <el-form-item
          label="上级医院名称"
          prop="hospitalCode"
          v-if="checkPermission()"
        >
          <el-select
            v-model="searchForm.hospitalCode"
            placeholder="请选择上级医院"
            style="width: 100%"
            :clearable="true"
          >
            <el-option
              v-for="item in hospitalList"
              :label="item.hospitalName"
              :key="item.id"
              :value="item.hospitalCode"
            />
          </el-select>
        </el-form-item>
        <el-form-item
          prop="siteStatus"
          label="启用状态"
        >
          <el-radio-group v-model="searchForm.siteStatus">
            <el-radio label="">全部</el-radio>
            <el-radio label="1">启用</el-radio>
            <el-radio label="2">停用</el-radio>
          </el-radio-group>
        </el-form-item>
        <div class="btns">
          <el-button
            type="primary"
            size="small"
            @click="search"
          >查询</el-button>
          <el-button
            size="small"
            @click="resetForm('searchForm')"
          >重置</el-button>
        </div>
      </el-form>
    </div>
    <div class="main-page-body">
      <div class="mainContent">
        <div class="bt">
          <el-button
            type="primary"
            size="small"
            v-if="checkPermission()"
            @click="exportFile()"
          >导出</el-button>
          <el-button
            type="primary"
            size="small"
            v-if="!checkPermission()"
            @click="showSaveDialog()"
          >新增</el-button>
        </div>
        <table-mixin
          :pageSize="pageSize"
          :pageNum="pageNum"
          :total="total"
          :pagination="pagination"
          :handleSizeChange="handleSizeChange"
          :handleCurrentChange="handleCurrentChange"
        >

          <el-table
            v-loading="tableData.loading"
            :data="tableData.body"
            @sort-change="handleSortChange"
          >
            <div
              slot="empty"
              class="noData"
            ></div>
            <el-table-column
              label="序号"
              type="index"
              min-width="50"
            >
            </el-table-column>
            <el-table-column
              v-for="(item,index) in tableData.head"
              :prop="item.key"
              :label="item.name"
              align="left"
              :formatter="item.formatter"
              :sortable="item.sortable"
              :fixed="item.fixed"
              :key="index"
              :min-width="item.width"
              :show-overflow-tooltip="true"
            >
            </el-table-column>
            <el-table-column
              label="操作"
              align="left"
              width="auto"
              min-width="200px"
            >
              <template slot-scope="scope">
                <el-link
                  type="primary"
                  @click="showSaveDialog('detail', scope.row.id)"
                >查看详情</el-link>
                <el-link
                  type="primary"
                  @click="showSaveDialog('update', scope.row.id)"
                  v-if="!checkPermission()"
                >修改</el-link>
                <el-link
                  type="primary"
                  @click="delHandler(scope.row.id)"
                  v-if="!checkPermission() && scope.row.auditStatus != 4"
                >删除</el-link>
                <el-link
                  type="primary"
                  v-if="scope.row.auditStatus === 1 && checkPermission()"
                  @click="auditHandler(scope.row.id)"
                >审核</el-link>
              </template>
            </el-table-column>
          </el-table>
        </table-mixin>
        <SiteDialog
          ref="siteDialog"
          @subsucc="search"
        />
      </div>
    </div>
  </div>
</template>
<script>
import { tableDataMixin } from '../../common/js/mixin'
import { queryEmergencySitePageList, deleteEmergencySite, auditEmergencySite } from '@/api/site'
import { getDic } from '../../util/dict'
import { queryEmergencyHospitalList, exportEmergencyResources } from '@/api/common'
import SiteDialog from './components/siteDialog.vue'
export default {
  name: 'sitePage',
  mixins: [tableDataMixin],
  components: {
    SiteDialog
  },
  data() {
    return {
      searchForm: {
        area: '',
        siteStatus: ''
      },
      areaList: [],
      hospitalList: [],
      tableData: {
        loading: false,
        head: [
          {
            name: '站点名称',
            key: 'siteName',
            sortable: false,
            width: '200',
            fixed: false
          },
          {
            name: '所在辖区',
            key: 'areaName',
            sortable: false,
            width: '120',
            fixed: false
          },
          {
            name: '站点位置',
            key: 'siteLocation',
            sortable: false,
            width: '120',
            fixed: false
          },
          {
            name: '上级医院名称',
            key: 'hospitalName',
            sortable: false,
            width: '200',
            fixed: false
          },
          {
            name: '启用状态',
            key: 'siteStatus',
            sortable: false,
            width: '80',
            fixed: false,
            formatter: this.siteStatusFormatter
          },
          {
            name: '审核状态',
            key: 'auditStatusName',
            sortable: false,
            width: '80',
            fixed: false
          }
        ],
        body: [],
        option: [],
        condition: []
      }
    }
  },
  mounted() {
    // 获取字典
    getDic(['area']).then(res => {
      this.areaList = res.area
    })
    //获取可选择的医院
    queryEmergencyHospitalList().then(res => {
      this.hospitalList = res.respData
    })
    this.search()
  },
  methods: {
    getTableData() {
      this.tableData.loading = true
      const params = {
        ...this.searchForm,
        pageNo: this.pageNum,
        pageSize: this.pageSize
      }
      queryEmergencySitePageList(params).then((res) => {
        if (res.msg == 201) {
          this.dealTableResponse(res)
        } else {
          this.$message.error(res.content)
        }
      })
    },
    showSaveDialog(type = 'add', id = '') {
      this.$refs.siteDialog.init(type, id)
    },
    auditHandler(id) {
      this.$confirm('是否审批通过？', '提示', {
        confirmButtonText: '通过',
        cancelButtonText: '拒绝',
        distinguishCancelAndClose: true,
        type: 'warning'
      }).then(() => {
        this.auditData(id, 2)
      }).catch(action => {
        if (action === 'cancel') {
          this.auditData(id, 3)
        }
      })
    },
    auditData(id, auditStatus) {
      auditEmergencySite({ id: id, auditStatus: auditStatus }).then(res => {
        if (res.msg === 201) {
          this.$message.success('操作成功！')
        } else {
          this.$message.error(res.content)
        }
        this.search()
      })
    },
    siteStatusFormatter(row, column, cellValue, index) {
      const siteStatusList = ['', '启用', '停用']
      return siteStatusList[cellValue] || ''
    },
    delHandler(id) {
      this.$confirm('此操作将永久删除该数据, 是否继续?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        deleteEmergencySite({ id: id }).then(res => {
          if (res.msg === 201) {
            this.$message.success('删除成功！')
          } else {
            this.$message.error(res.content)
          }
          this.search()
        })
      })
    },
    exportFile() {
      const params = {
        ...this.searchForm,
        exportType: 2
      }
      exportEmergencyResources(params).then(res => {
        if (res.msg === 201) {
          window.open(res.respData)
        } else {
          this.$message.success(res.content)
        }
      })
    },
  }
}
</script>
<style lang="scss" scoped>
.mainContent {
  padding: 20px;
  .bt {
    text-align: right;
    margin-bottom: 16px;
  }
}
</style>
